var xml2js   = require('xml2js'),
    rest     = require('restler'),
    crypto   = require('crypto'),
    mongoose = require('mongoose'),
    Schema   = mongoose.Schema,
    moment   = require('moment'),
    kue      = require('kue'),
    debugOn  = true;

var Insales = module.exports = function(config) {
  if(!(this instanceof Insales)) return new Insales(config);
  if(!config) config = {};
  this._name = config.name;
  this._processEvery = humanInterval(config.processEvery) || humanInterval('5 seconds');
  this._defaultConcurrency = config.defaultConcurrency || 5;
  this._maxConcurrency = config.maxConcurrency || 20;
  this._definitions = {};
  this._runningJobs = [];
  this._jobQueue = [];
  this._defaultLockLifetime = config.defaultLockLifetime || 10 * 60 * 1000; //10 minute default lockLifetime
  if(config.db)
    this.database(config.db.address, config.db.collection);
  else if(config.mongo)
    this._db =  config.mongo;
};

// Конфигурация

Insales.prototype.mongo = function(db) {
  this._db = db;
  return this;
};

Insales.prototype.database = function(url, collection) {
  collection = collection || 'agendaJobs';
  if (!url.match(/^mongodb:\/\/.*/)) {
    url = 'mongodb://' + url;
  }

  this._db = mongo.db(url, {w: 0}).collection(collection);
  return this;
};

Insales.prototype.name = function(name) {
  this._name = name;
  return this;
};

// exports = module.exports = insales;

// var appid,
//     appsecret,
//     mongodburi,
//     kueuri;

//Процедура установки
// exports.install = function(req, callback) {
//   log(req.query);
//   var pass = crypto.createHash('md5').update(req.query.token + appsecret).digest('hex');
//   log(pass);

//   Shop.findOne({ 'insales_id': req.query.insales_id }, function (err, shop) {
//     if (err) {
//       log(err)
//     } else {
//       if (shop) {
//         shop.pass = pass;
//         shop.updated_at = moment().format();
//         shop.enabled = true;
//         shop.save();
//         callback(req.query.insales_id);
//       } else {
//         shop = new Shop({
//           insales_id : req.query.insales_id,
//           url        : req.query.shop,
//           pass       : pass,
//           created_at : moment().format(),
//           updated_at : moment().format(),
//           enabled    : true
//         });

//         shop.save(function (err) {
//           if (err) {
//             log(err);
//           } else {
//             callback(req.query.insales_id);
//           }
//         });
//       }
//     }
//   });
// };

//Процедура удаления
exports.uninstall = function(req, callback) {
  log(req.query);
  Shop.findOne({ 'insales_id': req.query.insales_id }, function (err, shop) {
    if (err) {
      log(err)
    } else {
      if ((shop.insales_id == req.query.insales_id )&&(shop.pass == req.query.token)) {
        shop.pass = null;
        shop.updated_at = moment().format();
        shop.enabled = false;
        shop.save();
        callback('1');
      } else {
        callback('0');
      }
    }
  });
};

//Категории на складе

//Товары

//Изображения товара

//Модификации товара

//Свойства товара

//Значения свойств

//Дополнительные поля товара

//Значения дополнительных полей товара

//Сопутствующие товары

//Аналогичные товары

//Категории на сайте

//Размещение товаров на сайте

//Заказы

//Скидки по купонам

//Способы доставки

//Способы оплаты

//Домены

//Дополнительные поля адреса и покупателя

//Блоги

//Статьи

//Файлы

//Webhooks

//Widgets

//Уведомления
//Изначально выключено, включается только через partners@insales.ru

//JsTag
exports.jstagCreate = function(shopid, a, code, callback) {
  (a == 2) ? code = '<js-tag><type type=\"string\">JsTag::TextTag</type><content>' + code + '</content></js-tag>' : code = '<js-tag><type type=\"string\">JsTag::FileTag</type><content>' + code + '</content></js-tag>';
  Shop.findOne({ 'insales_id': shopid }, function (err, shop) {
    if (err) {
      log(err)
    } else {
      rest.post('http://' + shop.url + '/admin/js_tags.xml', {
        username: appid,
        password: shop.pass,
        headers: { 'Content-Type': 'application/xml' },
        parser : rest.parsers.xml,
        data   : code
      }).on('complete', function(data, response) {
        log(data);
        callback(data['text-tag'].id[0]._);
      });
    }
  });
};

exports.jstagDelete = function(shopid, callback) {

};

exports.jstagEdit = function(shopid, callback) {

};

exports.jstagList = function(shopid, callback) {

};

//Темы

//Ассеты

//Периодическое списание
exports.recurringChargeCreate = function(price, callback){
  var code = '<recurring-application-charge><monthly type=\"decimal\">' + price + '</monthly></recurring-application-charge>';
  Shop.findOne({ 'insales_id': shopid }, function (err, shop) {
    if (err) {
      log(err)
    } else {
      rest.post('http://' + shop.url + '/admin/js_tags.xml', {
        username: appid,
        password: shop.pass,
        headers: { 'Content-Type': 'application/xml' },
        parser : rest.parsers.xml,
        data   : code
      }).on('complete', function(data, response) {
        log(data);
        callback(data['text-tag'].id[0]._);
      });
    }
  });
};

exports.recurringChargeDelete = function(shopid, callback) {

};

exports.recurringChargeEdit = function(shopid, callback) {

};

exports.recurringChargeCheck = function(shopid, callback) {

};

//Счета

//Логгер в одном месте, для упрощения перезда на любой логгер.
function log(logMsg) {
  if (logMsg instanceof Error) console.log(logMsg.stack);
  if (debugOn) {
	  if (typeof logMsg == 'object') {
		  console.dir(logMsg);
	  } else {
		  console.log(logMsg);
	  }
  }
};

function insales(options){
  if (!options.id) log(new Error('Отсутствует идентификатор приложения'));
  if (!options.secret) log(new Error('Отсутствует секрет приложения'));
  if (!options.mongodb) log(new Error('Отсутствует адрес mongodb сервера'));
  if (!options.redis) log(new Error('Отсутствует адрес redis сервера'));

  appid      = options.id;
  appsecret  = options.secret;
  mongodburi = options.mongodb;
  kueuri     = options.kue;

  mongoose.connect(mongodburi);

  return function(req, res, next) {
    next();
  }
};

//mongodb
var ShopsSchema = new Schema();

ShopsSchema.add({
    insales_id  : { type: Number, index: true }
  , url         : { type: String, lowercase: true }
  , pass        : String
  , created_at  : Date
  , updated_at  : Date
  , enabled     : Boolean
});

var Shop = mongoose.model('Shop', ShopsSchema);
